using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace hex2array
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

private byte lda = 0;
private int ldb = 0;
private int GrandezzaFile = 0;
private int NumeroFile = 0;
private List <byte>Dati = new List<byte>();
private int NumeroDati = 0;
private int FileFiniti = 0;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            // TODO: use this.Content to load your game content here
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
           if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

//--------------------------------------------
for(;FileFiniti == 0;){

  //----apri file dat
  if(FileFiniti == 0){
    try{
      System.IO.Stream load = TitleContainer.OpenStream("Content/"+NumeroFile+".dat");System.IO.BinaryReader reader = new System.IO.BinaryReader(load);
      GrandezzaFile = (int)load.Length;
      for(int i=0; i<GrandezzaFile;){
        lda=reader.ReadByte(); Dati.Add(lda); NumeroDati++;
        i++;
      }
      reader.Close();}catch (System.IO.FileNotFoundException){FileFiniti = 1;}
  }

  //----apri file dds
  if(FileFiniti == 0){
    try{
      System.IO.Stream load = TitleContainer.OpenStream("Content/"+NumeroFile+".dds");System.IO.BinaryReader reader = new System.IO.BinaryReader(load);
      GrandezzaFile = (int)load.Length;
      for(int i=0; i<GrandezzaFile;){
        lda=reader.ReadByte(); Dati.Add(lda); NumeroDati++;
        i++;
      }
      NumeroFile++;
      reader.Close();}catch (System.IO.FileNotFoundException){}
  }

  //----se i file sono finiti, apri zzz.dat
  if(FileFiniti == 1){
    try{
      System.IO.Stream load = TitleContainer.OpenStream("Content/zzz.dat");System.IO.BinaryReader reader = new System.IO.BinaryReader(load);
      GrandezzaFile = (int)load.Length;
      for(int i=0; i<GrandezzaFile;){
        lda=reader.ReadByte(); Dati.Add(lda); NumeroDati++;
        i++;
      }
      reader.Close();}catch (System.IO.FileNotFoundException){}
  }

}
//----------------------
//----salva tto nel file compiled.big
try{System.IO.Stream save = new FileStream("Content/compiled.big", FileMode.Create);System.IO.BinaryWriter writer = new System.IO.BinaryWriter(save);
  for(int i=0; i<NumeroDati;){
    writer.Write(Dati[i]);
    i++;
  }
  writer.Close();}catch (System.IO.FileNotFoundException){}

//----------------------
            base.Draw(gameTime);
this.Exit();	//esci dp aver finito
        }
    }
}
