using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace hex2array
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

private byte lda = 0;
private int ldb = 0;
private int GrandezzaFile = 0;
private int NumeroFile = 0;
private int Indice = 0;
private int IndiceMax = 0;
private List <byte>Dati = new List<byte>();
private int TextureSalvata = 0;
private int GrandezzaTexture = 0;
private int GrandezzaTexture1 = 0;
private int GrandezzaTexture2 = 0;
private int GrandezzaTexture3 = 0;
private int GrandezzaTexture4 = 0;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            // TODO: use this.Content to load your game content here
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
           if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

//--------------------------------------------
//----apri file
  try{
    System.IO.Stream load = TitleContainer.OpenStream("Content/extract.big");
    System.IO.BinaryReader reader = new System.IO.BinaryReader(load);

    GrandezzaFile = (int)load.Length;

//----leggi file
  for(int i=0; i<GrandezzaFile;){
    lda=reader.ReadByte(); Dati.Add(lda);
    i++;
  }

//----chiudi file
    reader.Close();
    }
    catch (System.IO.FileNotFoundException)
    {
        // this will be thrown by OpenStream if gamedata.txt
        // doesn't exist in the title storage location
    }

//----LEGGI TUTTI I DATI
  for(int i=0; i<GrandezzaFile-4;){	//5-1

    TextureSalvata = 0;

//----se sei alla fine del file, salva gli ultimi dati
  if(i == GrandezzaFile-5){	//il 5 sono i dati letti per trovare la parola texture
    IndiceMax=i+3;	//segna che devi salvare fino a questo punto
    try{System.IO.Stream save = new FileStream("Content/zzz.dat", FileMode.Create);System.IO.BinaryWriter writer = new System.IO.BinaryWriter(save);
      for(int i2=Indice; i2<IndiceMax;){
        writer.Write(Dati[i2]);
        i2++;
      }
    writer.Close();}catch (System.IO.FileNotFoundException){}
    NumeroFile++; Indice = IndiceMax;
  }

//----salva dati fino a trovare dds
    if(Dati[i]==68 & Dati[i+1]==68 & Dati[i+2]==83){	//se trovi "DDS"
      IndiceMax=i;	//segna che devi salvare fino a questo punto
      try{System.IO.Stream save = new FileStream("Content/"+NumeroFile+".dat", FileMode.Create);System.IO.BinaryWriter writer = new System.IO.BinaryWriter(save);
        for(int i2=Indice; i2<IndiceMax;){
          writer.Write(Dati[i2]);
          i2++;
        }
      writer.Close();}catch (System.IO.FileNotFoundException){}
      Indice = IndiceMax;

//----salva texture (fino a trovare i 4byte00 e la scritta texture) (all'interno della stessa if)
      for(;TextureSalvata == 0;){
        if(Dati[i]==0 & Dati[i+1]==0 & Dati[i+2]==0 & Dati[i+3]==0 & Dati[i+4]==116){	//se trovi 4 byte 00 e la lettera "t"
          IndiceMax=i;	//segna che devi salvare fino a questo punto
          try{System.IO.Stream save = new FileStream("Content/"+NumeroFile+".dds", FileMode.Create);System.IO.BinaryWriter writer = new System.IO.BinaryWriter(save);
            for(int i2=Indice; i2<IndiceMax;){
              writer.Write(Dati[i2]);
              i2++;
            }
          writer.Close();}catch (System.IO.FileNotFoundException){}
          Indice = IndiceMax;
          NumeroFile++;
          TextureSalvata=1;
        }

        i++;	//avanza
      }		//fine for TextureSalvata
      i--;	//fix
    }		//fine if principale

//----FINE LETTURA DATI
    i++;
  }	//fine ciclo for

//----------------------
            base.Draw(gameTime);
this.Exit();	//esci dp aver finito
        }
    }
}
